﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.Collections.ObjectModel;
using System.Diagnostics;
using Infragistics;
using System.ComponentModel;
using System.Windows.Interactivity;
using Microsoft.Expression.Interactivity.Input;
using Microsoft.Expression.Interactivity.Layout;
using System.Runtime.CompilerServices;
using Infragistics.Controls.Schedules.Primitives;
using Infragistics.Windows.DataPresenter;

namespace TestProject
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}
	}
}

namespace Infragistics.Extensions
{
	public class DataPresenterExtensions
	{
		#region ActivateRecordUsingRightMouseButton

		/// <summary>
		/// ActivateRecordUsingRightMouseButton Attached Dependency Property
		/// </summary>
		public static readonly DependencyProperty ActivateRecordUsingRightMouseButtonProperty =
			DependencyProperty.RegisterAttached("ActivateRecordUsingRightMouseButton", typeof(bool), typeof(DataPresenterExtensions),
				new FrameworkPropertyMetadata((bool)false,
					new PropertyChangedCallback(OnActivateRecordUsingRightMouseButtonChanged)));

		public static bool GetActivateRecordUsingRightMouseButton(DependencyObject d)
		{
			return (bool)d.GetValue(ActivateRecordUsingRightMouseButtonProperty);
		}

		public static void SetActivateRecordUsingRightMouseButton(DependencyObject d, bool value)
		{
			d.SetValue(ActivateRecordUsingRightMouseButtonProperty, value);
		}

		private static void OnActivateRecordUsingRightMouseButtonChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
		{
			var dp = d as DataPresenterBase;

			if (null != dp)
			{
				if (true.Equals(e.NewValue))
				{
					dp.PreviewMouseRightButtonDown += new MouseButtonEventHandler(OnDataPresenterPreviewMouseRightButtonDown);
				}
				else
				{
					dp.PreviewMouseRightButtonDown -= new MouseButtonEventHandler(OnDataPresenterPreviewMouseRightButtonDown);
				}
			}
		}

		private static void OnDataPresenterPreviewMouseRightButtonDown(object sender, MouseButtonEventArgs e)
		{
			var drp = Infragistics.Windows.Utilities.GetAncestorFromType(e.OriginalSource as DependencyObject, typeof(DataRecordPresenter), true) as DataRecordPresenter;

			if (drp != null)
			{
				drp.Dispatcher.BeginInvoke(new Action(
					() =>
					{
						drp.DataPresenter.ActiveRecord = drp.Record;
					}), System.Windows.Threading.DispatcherPriority.ApplicationIdle, null);
			}
		}

		#endregion //ActivateRecordUsingRightMouseButton


	}
}
